#pragma once
#include "threads.hpp"

namespace JabyEngine {
    namespace Callback {
        namespace internal {
            static void execute_callback(Thread::Handle thread_handle) {
                if(CurrentThread::is_me(MainThread::Handle)) {
                    CurrentThread::replace_with(thread_handle);
                }

                SysCall::ReturnFromException();
            }

            namespace VSync {
                static constexpr size_t StackSize = 64;

                extern SysCall::ThreadHandle thread_handle;
                extern uint32_t              stack[StackSize];
                void                         routine();

                static void [[deprecated("Currently not in use")]] execute() {
                    execute_callback(VSync::thread_handle);
                }
            }

            namespace CD {
                static constexpr size_t StackSize = 256;

                extern SysCall::ThreadHandle thread_handle;
                extern uint32_t              stack[StackSize];

                static void execute() {
                    execute_callback(CD::thread_handle);
                }
            }
        }
    }
}
